#!/usr/bin/env ruby
require 'pp'

def parse_cpu(cpu)
    state = {}
    cpu.split(' ').each do |reg|
        reg =~ /([A-Z0-9]{2,3})=([0-9a-f]{16})/
        state[$1] = $2.to_i(16) if $1
    end
    return state
end

#a = File.open(ARGV.shift){|f| f.read()}
#traces = a.split("Trace ")*/
blocks = {}
f = ARGV.shift
if f=='-'
    f = $stdin 
else
    f = File.open(f, "r")
end
f.each do |t|
    next if t[0,5] != "Trace"
#    addr = t.lines[0][/.*\[(.*)\]/,1].to_i(16)
    addr = t.lines[0][22..37].to_i(16)
#    blocks[addr] = (blocks[addr] || [])<< parse_cpu(t.lines[1..-1].join(' '))
    blocks[addr] = (blocks[addr] || 0)+1
end
puts blocks.length
puts blocks.map { |entry| entry[0].to_s(16)+":"+entry[1].to_s}.join("\n")
